from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('AuthConfigProviderEntry')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereAuthConfigProviderEntry");
  exportedObject.put("roleName", "WebSphereAuthConfigProviderEntry");

  roleProperties = JSONObject();

  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('AuthConfigProviderEntry');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('AuthConfigProviderEntry')
  if not jsonobject.has("roleProperties"):
    raise Exception("AuthConfigProviderEntry resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  print "Creating AuthConfigProviderEntry with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("AuthConfigProviderEntry", parentid, properties);
  Util.popPathElement('AuthConfigProviderEntry');

def update(objid,jsonobject):
  Util.pushPathElement('AuthConfigProviderEntry')
  if not jsonobject.has("roleProperties"):
    raise Exception("AuthConfigProviderEntry resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  if len(atts) != 0:
    print "Modifying AuthConfigProviderEntry with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "AuthConfigProviderEntry configuration up to date.";

  Util.popPathElement('AuthConfigProviderEntry');
